/*!
 * WP Googel Analytics Events | v1.0
 * Copyright (c) 2013 Yuval Oren (@yuvalo)
 * License: GPLv2 */

/*jslint indent: 4 */
/*global $, jQuery, document, window, _gaq*/

var scroll_events = (function ($) {
    "use strict";

    var scroll_elements  = [];
    var click_elements = [];
    var link_click_delay = false;

    var track_event = function (category, action, label) {
        var event_category = !category ? '' : category;
        var event_action = !action ? '' : action;
        var event_label = !label ? '' : label;
        _gaq.push(['_trackEvent', category, action, label]);
    };


    var click_event = function (event) {

        track_event(event.data.category, event.data.action, event.data.label);
        if (event.data.hasOwnProperty('link_click_delay') && event.data.link_click_delay > 0 && event.currentTarget.hasOwnProperty('href')) {
            event.preventDefault();
            setTimeout(function () {
                window.location = event.currentTarget.href;
            }, link_click_delay);
        }
    };

    return {
        bind_events : function (settings) {
            scroll_elements = settings.scroll_elements;
            click_elements = settings.click_elements;
            link_click_delay = settings.link_clicks_delay;
            var i;
            for (i = 0; i < click_elements.length; i++) {
                var clicked = click_elements[i];
                clicked.link_click_delay = link_click_delay;
                $(clicked.select).on('click', clicked, click_event);
            }

            $('.clickevent').on('click', function (event) {
                event.data = {'category': $(this).attr('data-event-cat'), 'action': $(this).attr('data-event-action'), 'label': $(this).attr('data-event-label'), 'link_click_delay': link_click_delay};
                click_event(event);
            });



            $(window).scroll(function () {
                var ga_window = $(window).height();
                var ga_scroll_top = $(document).scrollTop();
                var i;
                for (i = 0; i < scroll_elements.length; i++) {
                    var scrollelement = scroll_elements[i];
                    if (!scrollelement.sent) {
                        var $select = $(scrollelement.select);
                        scrollelement.offset =  $select.offset();
                        if (scrollelement.offset && ga_scroll_top + ga_window >= scrollelement.offset.top + $select.height()) {
                            track_event(scrollelement.category, scrollelement.action, scrollelement.label);
                            scrollelement.sent = true;
                        }
                    }
                }

                $('.scrollevent').each(function () {
                    if (!$(this).hasClass('scrolled')) {
                        var scrolloffset = $(this).offset();
                        if (scrolloffset && ga_scroll_top + ga_window >= scrolloffset.top + $(this).height()) {
                            track_event($(this).attr('data-event-cat'), $(this).attr('data-event-action'), $(this).attr('data-event-label'));
                            $(this).addClass('scrolled');
                        }
                    }
                });
            });
        }
    };

}(jQuery));